module ImageMosaic
  module Image
    class Child
      def initialize(url)
        @url = url
      end

      def valid?
        image
        true
      rescue
        false
      end

      def width
        dimensions[0]
      end

      def height
        dimensions[1]
      end

      private

      def dimensions
        @dimensions ||= image.dimensions
      end

      def image
        @image ||= MiniMagick::Image.open(@url)
      end
    end
  end
end
