module ImageMosaic
  module Data
    class Background
      PATTERN = /^#([0-9a-fA-F]{3}){1,2}$/

      def initialize(hex)
        @hex = hex
      end

      def hex
        valid? ? @hex : COLOUR
      end

      private

      def valid?
        !!match
      end

      def match
        @hex =~ PATTERN
      end
    end
  end
end
