module ImageMosaic
  module Image
    class Mosaic
      attr_reader :image

      def initialize(image)
        @image = image
        @securerandom = SecureRandom.uuid
      end

      def save
        @image.write(filename)
      end

      def filename
        "mosaic_#{@securerandom}.png"
      end
    end
  end
end
